//
//  FX2USB.h
//  WaveControl
//
//  Created by Andrew Stagg on 20/04/07.
//  Copyright 2007 Andrew Stagg. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#include <unistd.h>
#include <CoreFoundation/CoreFoundation.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/IOCFPlugIn.h>
#include <IOKit/usb/IOUSBLib.h>
#include <mach/mach.h>
#include "xsvfparser.h"

#define	k8051_CPUCS			0xE600		// 8051 reset register (0xE600 on FX2)
#define kOurVendorID		0x04B4		// Vendor ID
#define kOurProductID		0x8613		// Product ID

#define MAX_INTEL_HEX_RECORD_LENGTH 17
typedef struct _INTEL_HEX_RECORD
{
	UInt32  	Length;
	UInt32 	Address;
	UInt32  	Type;
	UInt8  	Data[MAX_INTEL_HEX_RECORD_LENGTH];
} INTEL_HEX_RECORD, *PINTEL_HEX_RECORD;

@interface FX2USB : NSObject {
	
}

- (id)initWithController:(id)sender andFirmware:(NSString*)firmware andLoader:(NSString *)loader andVHDL:(NSString*)vhdl;
- (int)sendPlotter:(int)command;

void AcquireDevice();
IOReturn ConfigureDevice(IOUSBDeviceInterface **dev);
IOReturn WriteToDevice(IOUSBDeviceInterface **dev, UInt16 deviceAddress, UInt16 length, UInt8 writeBuffer[]);
IOReturn ReadFromDevice(IOUSBDeviceInterface **dev, UInt16 deviceAddress, UInt16 length, UInt8 readBuffer[]);
IOReturn DownloadToDevice(IOUSBDeviceInterface **dev, char *fname);
IOReturn FindInterfaces(IOUSBDeviceInterface **device);
IOReturn hexRead(INTEL_HEX_RECORD *record, FILE *hexFile);
void DeviceAdded(void *refCon, io_iterator_t iterator);
void DeviceRemoved(void *refCon, io_iterator_t iterator);
int send_plotter(int command);
int send_command(char buf[6]);
int send_data(char data[], int bytes);
int fx2_fpga_sendxsvf(char *filename);
int fx2_fpga_getsr();
int fx2_fpga_senddone();
@end
