#import "PlotterPilot.h"

@implementation PlotterPilot

- (void)awakeFromNib
{
	NSString *loader = [[NSBundle mainBundle] pathForResource:@"fpga_loader" ofType:@"hex"];
	NSString *firmware = [[NSBundle mainBundle] pathForResource:@"andrewusb" ofType:@"hex"];
	NSString *vhdl = [[NSBundle mainBundle] pathForResource:@"sdrive-oct13" ofType:@"xsvf"];
	
	usbdev = [[FX2USB alloc] initWithController:self andFirmware:[firmware retain] andLoader:[loader retain] andVHDL:[vhdl retain]];
}

- (IBAction)sendUSB:(id)sender
{
	if (sender == upButton)
		[usbdev sendPlotter:0xC];
	else if (sender == downButton)
		[usbdev sendPlotter:0x4];
	else if (sender == leftButton)
		[usbdev sendPlotter:0x10];
	else if (sender == rightButton)
		[usbdev sendPlotter:0x30];
	else if (sender == laserSwitch) {
		[usbdev sendPlotter:[sender state]];
	}
}

- (void)updateGUI:(BOOL)value
{
	[upButton setEnabled:value];
	[downButton setEnabled:value];
	[leftButton setEnabled:value];
	[rightButton setEnabled:value];
	[laserSwitch setEnabled:value];
}

- (void)dealloc
{
	[usbdev dealloc];
	[super dealloc];
}

@end
