#ifndef __xsvfparser__
#define __xsvfparser

/* DEFINES */
#define uchar        unsigned char
#define MAXLEN       128
#define FALSE        0
#define TRUE         1

/* XSVF commands */ 
#define XCOMPLETE    0x00
#define XTDOMASK     0x01
#define XSIR         0x02
#define XSDR         0x03
#define XRUNTEST     0x04
/* Reserved          0x05 */
/* Reserved          0x06 */
#define XREPEAT      0x07
#define XSDRSIZE     0x08
#define XSDRTDO      0x09
#define XSETSDRMASKS 0x0A
#define XSDRINC      0x0B
#define XSDRB        0x0C
#define XSDRC        0x0D
#define XSDRE        0x0E
#define XSDRTDOB     0x0F
#define XSDRTDOC     0x10
#define XSDRTDOE     0x11
#define XSTATE       0x12 
#define XENDIR       0x13
#define XENDDR       0x14

//  ---- JTAG Instructions ----
// 5 bit register
#define INST_EXTEST		0x00 // enables EXTEST operation
#define INST_SAMPLE		0x01 // enables SAMPLE operation
#define INST_USER1		0x02 // Access user defined register 1
#define INST_USER2		0x03 // Access user defined register 2
#define INST_CFG_OUT	0x04 // Config readback mode
#define INST_CFG_IN		0x05 // Config set mode
#define INST_INTEST		0x07 // enables INTEST operation
#define INST_USERCODE	0x08 // enables shifting out of user code
#define INST_IDCODE		0x09 // enables shifting out of id code
#define INST_HIGHZ		0x0A // Bypass with high impedence
#define INST_JSTART		0x0C // Start-up sequence
#define INST_BYPASS		0x1F // Bypass mode

/*
 * read a byte form the file 
 */
int readByte(uchar *ret);

/*
 * return an int value for a 4 char array
 */
int calcLength(uchar * ptr);

/*
 * Read in the TDI value specified by length
 */
void read_tdi();

/*
 * Fill a bufer with configuration data fromt he XSVF to be sent to the FX2
 */
void fillbigdata();

/*
 * puts total_length into buff for SIR
 */
void length_to_buff();

/*
 * flip the bits of a byte (because the data in XSVF needs to be sent LSB first)
 */
uchar flipbits(uchar c);

/*
 * parser - takes in a filename of an XSVF and parses and sends the data to the FX2
 */
int parse(char *file);

#endif