; usb-skel, intjmpvec.asm
;
; By Nathan Friess and Patrick McNeil
; April 12, 2005
; Modified: April 19, 2007 (added CODE)
; Contains the interrupt table.
; All of the zero's between entries are usable
; space.

		.area interrupt_area(ABS,CODE)

		.org 0x0000  ; Where the CPU starts execution
_entry::
		ljmp #0x0200 ; Jump to C entry point

_interrupt_table::
		ljmp #0xdead ; External INT 0
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; Timer 0
		.db 0x00, 0x00, 0x00, 0x00, 0x00
		
		ljmp #0xdead ; External INT 1
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; Timer 1
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; Serial port 0
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; Timer 2
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; RESUME
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; Serial port 1
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp _USB_autovector ; USB Autovector
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; I2C Interrupt
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp _GPIF_autovector ; FIFO/GPIF Autovector, or External INT 4
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; External INT 5
		.db 0x00, 0x00, 0x00, 0x00, 0x00

		ljmp #0xdead ; External INT 6


; Memory from 0x66 to 0xFF is reserved for USB descriptors
; See descriptors.asm



; USB Autovector table.
		.area usb_autovec_area(ABS,CODE)

; Must have lower byte as 0x00
		.org 0x0100

_USB_autovector::
_GPIF_autovector::
		ljmp _ISR_USB_sudav
		.db 0

		ljmp _ISR_USB_sof
		.db 0

		ljmp _ISR_USB_sutok
		.db 0

		ljmp _ISR_USB_susp
		.db 0

		ljmp _ISR_USB_ures
		.db 0

		ljmp _ISR_USB_highspeed
		.db 0

		ljmp _ISR_USB_ep0ack
		.db 0

		ljmp _ISR_USB_stub
		.db 0

		ljmp _ISR_USB_ep0in
		.db 0

		ljmp _ISR_USB_ep0out
		.db 0

		ljmp _ISR_USB_ep1in
		.db 0

		ljmp _ISR_USB_ep1out
		.db 0

		ljmp #0xdead ; EP2
		.db 0

		ljmp #0xdead ; EP4
		.db 0

		ljmp #0xdead ; EP6
		.db 0

		ljmp #0xdead ; EP8
		.db 0

		ljmp #0xdead ; IBN
		.db 0

		ljmp #0xdead ; SPARE
		.db 0

		ljmp #0xdead ; EP0 PING
		.db 0

		ljmp #0xdead ; EP1 PING
		.db 0

		ljmp #0xdead ; EP2 PING
		.db 0

		ljmp #0xdead ; EP4 PING
		.db 0

		ljmp #0xdead ; EP6 PING
		.db 0

		ljmp #0xdead ; EP8 PING
		.db 0

		ljmp #0xdead ; ERR LIMIT
		.db 0

		ljmp #0xdead ; SPARE
		.db 0

		ljmp #0xdead ; SPARE
		.db 0

		ljmp #0xdead ; SPARE
		.db 0

		ljmp #0xdead ; EP2ISOERROR
		.db 0

		ljmp #0xdead ; EP2ISOERROR
		.db 0

		ljmp #0xdead ; EP2ISOERROR
		.db 0

		ljmp #0xdead ; EP2ISOERROR
		.db 0
		
		; --- GPIF Autovectors ---
		; Cypress made a great design decision here.
		; The GPIF autovector can be back-to-back with the USB one.

		ljmp #0xdead ; EP2 Programmable
		.db 0

		ljmp #0xdead ; EP4 Programmable
		.db 0

		ljmp #0xdead ; EP6 Programmable
		.db 0

		ljmp #0xdead ; EP8 Programmable
		.db 0

		ljmp #0xdead ; EP2 Empty
		.db 0

		ljmp #0xdead ; EP4 Empty
		.db 0

		ljmp #0xdead ; EP6 Empty
		.db 0

		ljmp #0xdead ; EP8 Empty
		.db 0

		ljmp #0xdead ; EP2 Full
		.db 0

		ljmp #0xdead ; EP4 Full
		.db 0

		ljmp #0xdead ; EP6 Full
		.db 0

		ljmp #0xdead ; EP8 Full
		.db 0

		ljmp #0xdead ; GPIF Done
		.db 0

		ljmp #0xdead ; GPIF Waveform
		.db 0
