-- driver.vhd
-- Programmer: Andrew Stagg
-- Date: 2007-09-29
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity driver is
    Port ( CLK : in STD_LOGIC;
    	      EN : in STD_LOGIC;
           DIR : in STD_LOGIC;
           DRV : out STD_LOGIC_VECTOR (3 downto 0));
end driver;

architecture Behavioral of driver is

	signal drive: STD_LOGIC_VECTOR (3 downto 0);
	signal state : STD_LOGIC_VECTOR (1 downto 0);
	signal enable : STD_LOGIC;
	signal direct : STD_LOGIC;
	signal ready : STD_LOGIC;

begin

	DRV <= drive;
	enable <= EN;
	direct <= DIR;
	process (CLK, enable, direct, state)
	begin
		if rising_edge (CLK) then
			if enable = '0' then
				ready <= '1';	
			elsif ready = '1' and enable = '1' then
				ready <= '0';
				if direct = '0' then -- clockwise
					if state = "00" then
						drive <= "0011";
					elsif state = "01" then
						drive <= "0110";
					elsif state = "10" then
						drive <= "1100";
					else
						drive <= "1001";
					end if;
				else -- counter-clockwise
					if state = "00" then
						drive <= "1100";
					elsif state = "01" then
						drive <= "0110";
					elsif state = "10" then
						drive <= "0011";
					else
						drive <= "1001";
					end if;
				end if;
				state <= state + 1;
			end if;
		end if;
	end process;

end Behavioral;
