-- stepdrive.vhd
-- Programmer: Andrew Stagg
-- Date: 2007-10-13
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity stepdrive is
    Port (  CLK : in STD_LOGIC;
    		  XCTL : in STD_LOGIC_VECTOR (1 downto 0);
    		  YCTL : in STD_LOGIC_VECTOR (1 downto 0);
		  LCTL : in STD_LOGIC;
	       LAS : out STD_LOGIC;
	       DRVX : out STD_LOGIC_VECTOR (3 downto 0);
		  DRVY : out STD_LOGIC_VECTOR (3 downto 0));
end stepdrive;

architecture Behavioral of stepdrive is

	component driver
	Port ( CLK : in STD_LOGIC;
		  EN : in STD_LOGIC;
            DIR : in STD_LOGIC;
            DRV : out STD_LOGIC_VECTOR (3 downto 0));
	end component;

begin

	xdrive: driver port map ( CLK => CLK,
						 EN => XCTL(0),
						 DIR => XCTL(1),
						 DRV => DRVX);

	ydrive: driver port map ( CLK => CLK,
						 EN => YCTL(0),
						 DIR => YCTL(1),
						 DRV => DRVY);

	LAS <= LCTL;

end Behavioral;